package co.uk.fues.freudbot.ingest;

import com.google.gson.Gson;
import org.apache.commons.io.FileUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.config.CookieSpecs;
import org.apache.http.client.config.RequestConfig;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URIBuilder;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;

import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.time.LocalDateTime;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;

// If you are using the Academic Research product track at the Basic access level, you will be limited to receiving 10,000,000 Tweets per month across v2 endpoints noted earlier.

// When an application exceeds the rate limit for a given Twitter API endpoint, the API will return a HTTP 429 “Too Many Requests” response code, and the following error will be returned in the response body:

//{ "errors": [ { "code": 88, "message": "Rate limit exceeded" } ] }

// App rate limit: 300 requests per 15-minute window = every 3 seconds
// App rate limit: 1 request per second

public class TwitterAPI {
    String Bearer = "AAAAAAAAAAAAAAAAAAAAACAiPAEAAAAAdVPPCQZgmTiaKBIfXVN9F4ux0ro%3Df1mgPnpzrJxx4hlxrymFgJ9Sg7snFSehTOZakURJmjlKBJOFU2";//getToken();

    public static void main(String [] args) throws IOException, URISyntaxException, InterruptedException {

        String resultsFileName = "/data/tweetresults";

        TwitterAPI api = new TwitterAPI();

//        TwitterSearchResult searchResult = api.search("\"you are a bot\" -is:retweet", null, 100);
//        searchResult.getData();
//        api.runDeclarationCollection(resultsFileName);
        api.runConvo();
    }

    public void runConvo() throws IOException {
        Gson gson = new Gson();
        File dir = new File(System.getProperty("user.dir") + "/data");
        List<Tweet> tws = FileUtils.readLines(new File(dir+"/tweetresults0.txt")).stream().map(line -> gson.fromJson(line, Tweet.class)).collect(Collectors.toList());

        List<Tweet> tweets = new ArrayList<>();
        List<Tweet> newtweets = new ArrayList<>();
        tweets.addAll(tws);

        tweets = tweets.subList(0,8000);
        AtomicInteger round = new AtomicInteger();
        AtomicInteger go = new AtomicInteger(0);

        tweets.forEach(id -> {
            try {
                List<Tweet> res = convoSearch(id.getConversation_id()).getData();
                if(res!=null) {
                    newtweets.addAll(res);
                }
                round.getAndIncrement();
                if(newtweets.size() >1000) {
                    go.getAndIncrement();
                    List<String> jsonTweets = newtweets.stream().map(gson::toJson).collect(Collectors.toList());
                    FileUtils.writeLines(new File(System.getProperty("user.dir") + "/conversations" + go.get() + ".txt"), jsonTweets);
                    round.set(0);
                    newtweets.clear();
                }

                Thread.sleep(3000);
            } catch (IOException e) {
                e.printStackTrace();
            } catch (URISyntaxException e) {
                e.printStackTrace();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        });

        List<String> jsonTweets = newtweets.stream().map(tweet -> gson.toJson(tweet)).collect(Collectors.toList());
        FileUtils.writeLines(new File(System.getProperty("user.dir") + "/conversations.txt"), jsonTweets);
    }

    public void runDeclarationCollection(String resultsFileName) throws IOException, URISyntaxException, InterruptedException {
        String nextToken = null;
        List<Tweet> allResults = new ArrayList<>();
        Gson gson = new Gson();
        int resultsIteration = 0;
        int totalResults = 1000000;
        int resultsPerCall = 500;
        int calls = totalResults/resultsPerCall;
        Set<Tweet> tweets = new HashSet<>();
        String endTime = LocalDateTime.now().minusDays(1).toString() + "Z";
        for (int i=0;i<calls;i++) {
            ArrayList<NameValuePair> queryParameters = new ArrayList<>();
            queryParameters.add(new BasicNameValuePair("end_time", endTime));
            TwitterSearchResult searchResult = search("\"you are a bot\" -is:retweet", nextToken, resultsPerCall, queryParameters);
//            if(searchResult.getMeta().getNext_token()!=null) {
//                nextToken = searchResult.getMeta().getNext_token();
//            }
            List<Tweet> latestResults = searchResult.getData();
            endTime = latestResults.get(latestResults.size()-1).getCreated_at();
            allResults.addAll(latestResults);
            tweets.addAll(searchResult.getData());
            if(allResults.size()>10000) {
                writeResults(resultsFileName + resultsIteration + ".txt", allResults, gson);
                resultsIteration++;
                allResults.clear();
            }
            Thread.sleep(1000*4);
        }
        resultsIteration++;
        writeResults(resultsFileName + resultsIteration + ".txt", allResults, gson);
        resultsIteration++;
        allResults.clear();
    }

    private void writeResults(String resultsFileName, List<Tweet> allResults, Gson gson) throws IOException {
        Map<String, Tweet> textToTweet = new HashMap<>();
        allResults.forEach(res -> {
            textToTweet.put(res.getText(), res);
        });
        List<String> tweets = textToTweet.values().stream().map(tweet -> gson.toJson(tweet)).collect(Collectors.toList());

        File file = new File(System.getProperty("user.dir") + resultsFileName);
        file.createNewFile();
        FileUtils.writeLines(file, tweets);
    }

    public TwitterSearchResult convoSearch(String conversationId) throws IOException, URISyntaxException {
        TwitterSearchResult searchResult = search(" conversation_id:"+conversationId, null, 100, new ArrayList<>());
        return searchResult;
        //https://api.twitter.com/2/tweets?ids=1225917697675886593&tweet.fields=author_id,conversation_id,created_at,in_reply_to_user_id,referenced_tweets&expansions=author_id,in_reply_to_user_id,referenced_tweets.id&user.fields=name,username' \
        //  --header 'Authorization: Bearer $BEARER_TOKEN'
    }
    public TwitterSearchResult search(String searchString, String pageToken, int results, ArrayList<NameValuePair> extraParameters) throws IOException, URISyntaxException {
        String searchResponse = null;

        HttpClient httpClient = HttpClients.custom()
                .setDefaultRequestConfig(RequestConfig.custom()
                        .setCookieSpec(CookieSpecs.STANDARD).build())
                .build();

        URIBuilder uriBuilder = new URIBuilder("https://api.twitter.com/2/tweets/search/all");
        ArrayList<NameValuePair> queryParameters;
        queryParameters = new ArrayList<>();

        queryParameters.add(new BasicNameValuePair("query", searchString));
        queryParameters.add(new BasicNameValuePair("max_results", String.valueOf(results)));
        if(pageToken!=null) {
            queryParameters.add(new BasicNameValuePair("next_token", pageToken));
        }
        queryParameters.add(new BasicNameValuePair("expansions", "author_id"));
        queryParameters.add(new BasicNameValuePair("tweet.fields", "created_at,conversation_id"));
        queryParameters.addAll(extraParameters);
        uriBuilder.addParameters(queryParameters);

        HttpGet httpGet = new HttpGet(uriBuilder.build());
        httpGet.setHeader("Authorization", String.format("Bearer %s", Bearer));
        httpGet.setHeader("Content-Type", "application/json");

        HttpResponse response = httpClient.execute(httpGet);
        HttpEntity entity = response.getEntity();
        if (null != entity) {
            searchResponse = EntityUtils.toString(entity, "UTF-8");
        }
        Gson gson = new Gson();
        return gson.fromJson(searchResponse, TwitterSearchResult.class);
    }

}
